******************************************************************************
*
*       Function:   GET_READ_ATTN
*       Usage:      call get_read_attn (proc_structure, routine)
*       Purpose:    This routine is used to establish a READATTN ast on the
*                   mailbox associated with a subprocesses SYS$INPUT.  This
*                   allows us to know when a process is idle so that we can
*                   detect transitions between new, busy, and idle processes.
*       Output:     A READATTN request.
*
******************************************************************************

        subroutine get_read_attn (proc, rout)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            record /sub_proc/ proc
            external rout

            call signal (sys$qiow (
     .             ,
     .             %val(proc.mailchan),
     .             %val(IO$_SETMODE+IO$M_READATTN),
     .             proc.iosb,
     .             , ,
     .             rout,
     .             proc,
     .             , , , ))

        end
