******************************************************************************
*
*       Function:   OPEN_ERRLOG
*       Usage:      call open_errlog (return_status)
*       Purpose:    This routine opens the error log file.
*       Output:     The ERRUNIT I/O unit will be valid for output to the
*                   error log.
*
******************************************************************************

        subroutine open_errlog (iostat)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer iostat, i

            i = 1
            do while (i .lt. 5)
                open (unit=ERRUNIT, status='UNKNOWN', file=ERRFILE,
     .              access='APPEND', shared, recl=30000, err = 1,
     .              iostat = iostat)
                goto 5
  1             i = i + 1
            end do

            open (unit=ERRUNIT, status='NEW', file=ERRFILE,
     .            shared, iostat = iostat, recl=30000, err = 5)

  5         continue
        end
