******************************************************************************
*
*       Function:   PROCESS
*       Usage:      call process (0)
*       Purpose:    This routine is called by the main processing loop of
*                   symbiont.  It reads the message that the JBC sent us,
*                   and then dispatches the appropriate routine to take
*                   care of handling the request.
*       Output:     Some action as prescribed by the request.
*
******************************************************************************

        subroutine process (dummy)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer stream, request, idx, dummy
            character dbuf(1:8192)
            record /dynam/ data
            external errlog

            data.class = 0
            data.type = 0
            data.length = 8192
            data.address = %loc (dbuf)
            
*           Get the work to be done.

            call signal (SMB$READ_MESSAGE (stream, data, request))

            last_stream = stream

*           Select the specific routine that we need to call

            if (request .eq. SMBMSG$K_START_STREAM) then
                call start_stream (stream, data, request)
            else if (request .eq. SMBMSG$K_STOP_STREAM) then
                call stop_stream (stream, data, request)
            else if (request .eq. SMBMSG$K_RESET_STREAM) then
                call reset_stream (stream, data, request)
            else if (request .eq. SMBMSG$K_START_TASK) then
                call start_task (stream, data, request)
            else if (request .eq. SMBMSG$K_STOP_TASK) then
                call stop_task (stream, data, request)
            else if (request .eq. SMBMSG$K_PAUSE_TASK) then
                call pause_task (stream, data, request)
            else if (request .eq. SMBMSG$K_RESUME_TASK) then
                call resume_task (stream, data, request)
            else
                call errlog ('Unrecognized symbiont request', stream, request)
            endif
        end
