******************************************************************************
*
*       Function:   STOP_TASK
*       Usage:      call stop_task (SMB_stream_id, data_descr, SMB_request)
*       Purpose:    This routine is used to process the STOP_TASK requests
*                   from the JBC.  This routine deletes all processes that
*                   are associated with the indicated stream, and then
*                   replys to the JBC that we have completed the request.
*       Output:     One less task executing.
*
******************************************************************************

        subroutine stop_task (stream, data, request)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'

            integer stream, request, i, stat
            record /dynam/ data

            external get_info, reply, log_str

*           Get all of the information.

            call get_info (stream, data, request, MAXPROCS+1)

            last_idx = MAXPROCS+1

*           Search for processes active in this stream.  Note that the
*           JBC sends us NO information about the task, because it assumes
*           that a single queue has a single entry executing in it.  We
*           therefore adopt the policy of deleting any process that is
*           active and associated with the indicated stream.

            do i=1,MAXPROCS
                if ((.not. procs(i).avail) .and.
     .                          (procs(i).stream .eq. stream)) then

*                   Delete the process

                    procs(i).dying = .true.
                    stat = sys$delprc (procs(i).pid,)
                    if ((stat.and.1).ne.1) then
                        call log_str (%val (stat),
     .                      'Can''t delete process in stop_task')
                    endif
                endif
            end do

*           Report that we are done

            call reply (SS$_NORMAL, SMBMSG$K_STOP_TASK, stream)
        end
