******************************************************************************
*
*       Function:   STRCMP
*       Usage:      if (strcmp (character*(*), character*(*))) then
*       Purpose:    This routine performs a case blind comparison of the
*                   two strings passed, and returns a boolean value indicating
*                   whether or not they are equal (ignoring case).
*       Output:     Logical, true or false.
*
******************************************************************************

        logical function strcmp (str1, str2)
            implicit none
            include 'defs.inc'
            include 'struct.inc'
            include 'extern.inc'
            include 'global.inc'
        
            character*(*) str1, str2
            external str$case_blind_compare
            integer str$case_blind_compare, stat

            stat = str$case_blind_compare (str1, str2)

            strcmp = .true.
            if (stat.ne.0) strcmp = .false.
        end
